#include <limits.h>
#include "unity.h"

#include "mesh_ota.h"





TEST_CASE("Remote got patch", "[distinguish newer image version]")
{
    char versionLocal[] = "1.2.3";  //current running image
    char versionRemote[] = "1.2.4"; //image from server
   TEST_ASSERT_TRUE( bNewerVersion(versionLocal, versionRemote)  );
}

TEST_CASE("Remote got minor", "[distinguish newer image version]")
{
    char versionLocal[] = "1.2.3";  //current running image
    char versionRemote[] = "1.3.3"; //image from server
   TEST_ASSERT_TRUE( bNewerVersion(versionLocal, versionRemote)  );
}

TEST_CASE("Remote got major", "[distinguish newer image version]")
{
    char versionLocal[] = "1.2.3";  //current running image
    char versionRemote[] = "2.2.3"; //image from server
   TEST_ASSERT_TRUE( bNewerVersion(versionLocal, versionRemote)  );
}

TEST_CASE("Local got patch", "[distinguish newer image version]")
{
    char versionLocal[] = "1.2.4";  //current running image
    char versionRemote[] = "1.2.3"; //image from server
   TEST_ASSERT_FALSE( bNewerVersion(versionLocal, versionRemote)  );
}

TEST_CASE("Local got minor", "[distinguish newer image version]")
{
    char versionLocal[] = "1.3.3";  //current running image
    char versionRemote[] = "1.2.3"; //image from server
   TEST_ASSERT_FALSE( bNewerVersion(versionLocal, versionRemote)  );
}

TEST_CASE("Local got major", "[distinguish newer image version]")
{
    char versionLocal[] = "2.2.3";  //current running image
    char versionRemote[] = "1.2.3"; //image from server
   TEST_ASSERT_FALSE( bNewerVersion(versionLocal, versionRemote)  );
}

TEST_CASE("Remote got alpha and patch", "[distinguish newer image version]")
{
    char versionLocal[] = "2.2.3";  //current running image
    char versionRemote[] = "a2.2.4"; //image from server
   TEST_ASSERT_TRUE( bNewerVersion(versionLocal, versionRemote)  );
}

TEST_CASE("Remote got max", "[distinguish newer image version]")
{
    char versionLocal[] = "2.2.3";  //current running image
    char versionRemote[] = "999.999.999"; //image from server
   TEST_ASSERT_TRUE( bNewerVersion(versionLocal, versionRemote)  );
}
